import { CLIOptions } from 'storybook/internal/types';
import { BuilderOutput, Builder as DevkitBuilder } from '@angular-devkit/architect';
import { StylePreprocessorOptions } from '@angular-devkit/build-angular';
import { AssetPattern, SourceMapUnion, StyleElement } from '@angular-devkit/build-angular/src/builders/browser/schema';
import { JsonObject } from '@angular-devkit/core';
export type StorybookBuilderOptions = JsonObject & {
    browserTarget?: string | null;
    tsConfig?: string;
    compodoc: boolean;
    compodocArgs: string[];
    enableProdMode?: boolean;
    styles?: StyleElement[];
    stylePreprocessorOptions?: StylePreprocessorOptions;
    assets?: AssetPattern[];
    preserveSymlinks?: boolean;
    sourceMap?: SourceMapUnion;
    experimentalZoneless?: boolean;
} & Pick<CLIOptions, 'port' | 'host' | 'configDir' | 'https' | 'sslCa' | 'sslCert' | 'sslKey' | 'smokeTest' | 'ci' | 'quiet' | 'disableTelemetry' | 'initialPath' | 'open' | 'docs' | 'debugWebpack' | 'webpackStatsJson' | 'statsJson' | 'loglevel' | 'previewUrl'>;
export type StorybookBuilderOutput = JsonObject & BuilderOutput & {};
declare const _default: DevkitBuilder<StorybookBuilderOptions & JsonObject>;
export default _default;
